// BonCasService.cpp : WinMain ̎


#include "stdafx.h"
#include "resource.h"
#include "BonCasService.h"
#include "CasServer.h"
#include "DnpService.h"
#include <stdio.h>


class CBonCasServiceModule : public CAtlServiceModuleT< CBonCasServiceModule, IDS_SERVICENAME >,
							 private CCasServer::ICasServerHandler
{
public :
	DECLARE_LIBID(LIBID_BonCasServiceLib)
	DECLARE_REGISTRY_APPID_RESOURCEID(IDR_BONCASSERVICE, "{94799C2A-D5C7-4231-8F11-A3E492A14E5B}")

	CBonCasServiceModule()
		: m_CasServer(this)
		, m_wServerPort(6900U)
	{
		// RXgN^
	}

	HRESULT InitializeSecurity() throw()
	{
		// TODO : CoInitializeSecurity ĂяoAT[rXɓK؂ȃZLeBݒ 
		// w肵܂B
		//  - PKT x̔F؁A 
		// RPC_C_IMP_LEVEL_IDENTIFY ̋UxA 
		// ѓK؂ NULL ȊÕZLeBLqqB

		return S_OK;
	}

	//
	//	R}hC̒ǉ
	//
	//	ȉ3̃R}hCIvVǉB
	//
	//	xxx.exe /Start		F@T[rXJn
	//	xxx.exe /Stop		F	T[rX~
	//	xxx.exe /Restart	F	T[rXċN
	//
	bool ParseCommandLine(LPCTSTR lpCmdLine, HRESULT* pnRetCode) throw()
	{
		if(!__super::ParseCommandLine(lpCmdLine,pnRetCode))return false;

		bool ret;
		CString strName;
		CDnpService	cService;

		TCHAR szTokens[] = _T("-/");
		*pnRetCode = S_OK;

		LPCTSTR lpszToken = FindOneOf(lpCmdLine, szTokens);

		while(lpszToken != NULL)
		{
			if(WordCmpI(lpszToken, _T("Start")) == 0)
			{
				//T[rX̊Jn
				strName.LoadString(IDS_SERVICENAME);
				ret = cService.EasyStart(strName);
				*pnRetCode = ret ? S_OK : E_FAIL;
				
				if(*pnRetCode == S_OK)::MessageBox(NULL, TEXT("T[rX͐ɊJn܂"), TEXT("BonCasService"), MB_OK);
				else ::MessageBox(NULL, TEXT("T[rXo^Ă܂\r\n\r\n/Service IvVœo^Ă"), TEXT("BonCasService"), MB_OK);
				
				return false;
			}

			if(WordCmpI(lpszToken, _T("Stop")) == 0)
			{
				//T[rX̒~
				strName.LoadString(IDS_SERVICENAME);
				ret = cService.EasyStop(strName);
				*pnRetCode = ret ? S_OK : E_FAIL;
				
				if(*pnRetCode == S_OK)::MessageBox(NULL, TEXT("T[rX͐ɒ~܂"), TEXT("BonCasService"), MB_OK);
				else ::MessageBox(NULL, TEXT("T[rXo^Ă܂\r\n\r\n/Service IvVœo^Ă"), TEXT("BonCasService"), MB_OK);
				
				return false;
			}

			if(WordCmpI(lpszToken, _T("Restart")) == 0)
			{
				//T[rX̍ċN
				strName.LoadString(IDS_SERVICENAME);
				ret = cService.EasyRestart(strName);
				*pnRetCode = ret ? S_OK : E_FAIL;
				
				if(*pnRetCode == S_OK)::MessageBox(NULL, TEXT("T[rX͐ɍċN܂"), TEXT("BonCasService"), MB_OK);
				else ::MessageBox(NULL, TEXT("T[rXo^Ă܂\r\n\r\n/Service IvVœo^Ă"), TEXT("BonCasService"), MB_OK);
				
				return false;
			}

			lpszToken = FindOneOf(lpszToken, szTokens);
		}

		return true;
	}

	HRESULT PreMessageLoop(int nShowCmd)
	{
		HRESULT hr = __super::PreMessageLoop(nShowCmd);

		#if _ATL_VER >= 0x0700
			if(SUCCEEDED(hr) && !m_bDelayShutdown)
			{
				hr = CoResumeClassObjects();
			}
		#endif

		if(SUCCEEDED(hr))
		{
			// ݒt@C̃pX\z
			TCHAR szDrive[_MAX_DRIVE + 1] = {TEXT('\0')};
			TCHAR szDir[_MAX_DIR + 1] = {TEXT('\0')};
			TCHAR szFile[_MAX_FNAME + 1] = {TEXT('\0')};
		
			::GetModuleFileName(NULL, m_szConfigPath, sizeof(m_szConfigPath) - 1);
			::_tsplitpath(m_szConfigPath, szDrive, szDir, szFile, NULL);
			::_tmakepath(m_szConfigPath, szDrive, szDir, szFile, TEXT("ini"));

			m_wServerPort = (WORD)::GetPrivateProfileInt(TEXT("General"), TEXT("ServerPort"), m_wServerPort, m_szConfigPath);

			// ɃT[rX̏ɕKvȏ܂
			m_CasServer.OpenServer(m_wServerPort);
		}

		return hr;
	}

	HRESULT PostMessageLoop(void)
	{
		// ɃT[rXIɕKvȌ㏈܂B
		m_CasServer.CloseServer();
		
		// ݒۑ
		TCHAR szValue[1024];
		::_stprintf(szValue, TEXT("%u"), m_wServerPort);
		::WritePrivateProfileString(TEXT("General"), TEXT("ServerPort"), szValue, m_szConfigPath);

		return __super::PostMessageLoop();
	}

protected:
	virtual void OnCasServerEvent(CCasServer *pCasServer, const WORD wEventID)
	{
	
	}

	CCasServer m_CasServer;
	WORD m_wServerPort;
	TCHAR m_szConfigPath[_MAX_PATH];
};

CBonCasServiceModule _AtlModule;




extern "C" int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nShowCmd)
{
#ifdef _DEBUG
	// [NoL
	::_CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF | ::_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG)); 
#endif
 
    return _AtlModule.WinMain(nShowCmd);
}

